---
title: Collections
description: 
published: true
date: 2022-08-29T20:17:25.206Z
tags: 
editor: markdown
dateCreated: 2022-05-02T19:45:35.721Z
---

# Collections and Data Structures

People collect things.   Somtimes those things are physical items such as trading cards, stamps, marbles, and coins.
People who have physical collections of things usually keep the different types of collections separated.  The coins will be in a separate box or container from the trading cards, for example.
Collectors who have more than one collection rarely mix types.  

![A collection of coins and stamps in no particular order. Image mostly decorative.](/images/collectionsinreallife.png)

### Collections of data
Computer programs often required sets, or collections of data in order to operate.  Programs like personal organizers, library catalogs, and student-record systems have clear needs for sets of data as do inventory systems for stores, banking applications, and document management.   Collections are found in less obvious applications as well. A text editor may keep track of a set of 'recent files', a web browser keeps track of cookies and browsing history, and SMS apps keep track of messages sent and received.

In all of these cases the number of items to be stored changes with the operation of the program.  Items may be added and deleted and edited in normal operation of the application. 

As with real-life collections, it works better if we keep similar things together.

#### Data Structures

The term **data structure** is used to describe specific programming constructs designed to help the programmer manage the data that software needs to operate.   Most programming languages come with some built in data structures such as stacks, trees, and lists.    

Each type of data structure has characteristics that render it good in some situations and less good in others.  A course in data structures is beyond the scope of this resource, but such a course is highly recommended if you have not already taken one.

#### Collections: Data Structures in Java

Java provides many data structures for use by programmers.   In Java these structures are known as **collections**.  
 
* A Java collection can hold a single type of object.
* Java comes several useful collections found in the `java.util` package.
   * e.g. ArrayList, Vector, LinkedList, HashMap

#### Practice

- [Self Study Exercises and Practice Problems](/practiceActivities/dataStructures/collectionsDataStructures)


