---
title: UX Design
description: 
published: 1
date: 2022-08-17T20:11:37.881Z
tags: 
editor: markdown
dateCreated: 2022-08-17T18:13:55.028Z
---

# User Interfaces

A **User Interface** is simply the mechanism that a human uses to interact with something. We think of user interfaces as being specific to computers, but most human constructions have some kind of an interface that allows humans to interact with them. A door has knobs or handles that facilitate opening or closing the door. A shovel or rake has a different kind of handle that facilitates digging or raking. A bicycle has pedals, a seat and handlebars to facilitate riding the bike.

A user interface isn't inherently good or bad. It's value depends on how well it helps users accomplish the tasks that the item is meant to be used for. Computer program interfaces are no different. Some have great interfaces that help the user get work done. Some have less good interfaces.

While every computer program, even a command line utility, presents some kind of user interface, we often don't discuss UX design until the programmer is ready to study the construction of graphical user interfaces (a GUI).

## UX Design Process
A good UX design requires that the designer understand the context of the program extremely well. The designer/programmer must:
1. Understand the characteristics of the intended users
1. Understand the characteristics of the intended tasks


### Intended Users
The user interface should be designed to meet the needs of the target audience.  If the intended users of a system are novices, then a good UX design will focus on consistent vocabulary, limited choices in menus, and detailed feedback about the choices made. On the other hand, if the intended users are experts, then the design should focus on quick and efficient comments, easy access to advanced features and feedback that doesn't distract from the task. Additional considerations must be made when users have physical or cognitive characteristics that impact how they use computing such as vision or dexterity impairments.

### Intended Tasks
A user interface is intended to help the user accomplish tasks or goals that the software can assist with. Before any UX design can be attempted, a thorough understanding of the purpose of the program and the tasks it enables must be gained.

The components of the user interface should be organized to allow users to accomplish tasks with minimum effort on the part of the user.

### Preventing Errors
Users make mistakes. They type the wrong letters. They click the mouse where they shouldn't. They choose the wrong menu item. A large part of UX design time should be spent designing the interface so that it is difficult for users to make mistakes. For example, the interface could be designed so that actions that are not appropriate for the current state of the program are greyed out. Text entry fields can be designed to check the input prior to submitting to the program. Breadcrumbs can be used to help the user understand the context of the current operation. Buttons and fields that repeat on multiple screens can be designed to always be in the same location.


## Evaluating User Interfaces
The field of study associated with user interface design is called **Human Computer Interaction**. Within that field there are many sets of guidelines for constructing and evaluating user interfaces. Often the evaluation of a user interface involves watching people use the interface as well as surveying them to get their feedback on the interface. A generalized checklist for assessing user interfaces is shown below.

- *Learnability*  How long does it take a typical user to become comfortable using the interface?  Is it easy for them to remember how to use it between sessions? 
- *Efficiency*  How long does it take a user to accomplish the task they are doing?  Can they do it with few interactions?  Do they have to re-enter information in more than one spot?
- *Error rate*  How many errors do users make?  Does the rate of errors decrease as they learn the UI?  Are error rates the same for all of the tasks?
- *User Satisfaction*  Do users like the interface? Do they report that it lets them do what they need to do?

